#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif


#define MAXPOINTS 20

attribute vec2 a_texCoord;
varying vec2 v_texCoord;
varying vec2 v_originTexCoord;


uniform float aspectRatio;

uniform vec2 center[MAXPOINTS];
uniform vec2 radius[MAXPOINTS];
uniform float scale[MAXPOINTS];
uniform float angle[MAXPOINTS];
uniform float u_min[MAXPOINTS];
uniform float u_max[MAXPOINTS];

uniform lowp int types[MAXPOINTS];
uniform lowp int count;


uniform float progress;

vec2 distortion(vec2 uv, int i) {
    
    vec2 textureCoordinateToUse = uv;
    
    float e1 =  ( textureCoordinateToUse.x - center[i].x ) / ( radius[i].x );
    float e2 =  ( textureCoordinateToUse.y - center[i].y ) / ( radius[i].y / aspectRatio );
    float d  = (e1 * e1) + (e2 * e2);
    
    
    if (d < 1.0)
    {
        
        
        
        if(types[i] == 1) {
            
            // bulge
            vec2 dist = vec2(d * radius[i].x, d * radius[i].y);
            textureCoordinateToUse -= center[i];
            
            vec2 delta = ((radius[i] - dist) / radius[i]);
            float deltaScale = scale[i];
            if(deltaScale > 0.0) {
                deltaScale = smoothstep(u_min[i], u_max[i], deltaScale);
            }
            
            vec2 percent = 1.0 - ((delta * deltaScale) * progress);
            textureCoordinateToUse = textureCoordinateToUse * percent;
            uv = textureCoordinateToUse + center[i];
            
            
        } else if(types[i] == 2) {
            
            // shift
            
            float dist = 1.0 - d;
            float delta = scale[i] * dist * progress;
            
            float deltaScale = smoothstep(u_min[i], u_max[i], dist);
            float directionX = cos(angle[i]) * deltaScale;
            float directionY = sin(angle[i]) * deltaScale;
            
            
            uv = vec2(textureCoordinateToUse.x - (delta * directionX), textureCoordinateToUse.y -  (delta * directionY));
            
        }
        
    }
    
    return uv;
    

}


void main()
{


    
    
    vec2 uv = a_texCoord;
    v_originTexCoord = a_texCoord;
    
    gl_Position = vec4(uv * 2.0 - 1.0, 0.0, 1.0);

    
    
    v_texCoord = uv;
    
    
    
    if(0 >= count) return;
    v_texCoord = distortion(v_texCoord, 0);
    
    if(1 >= count) return;
    v_texCoord = distortion(v_texCoord, 1);
    
    if(2 >= count) return;
    v_texCoord = distortion(v_texCoord, 2);
    
    if(3 >= count) return;
    v_texCoord = distortion(v_texCoord, 3);
    
    if(4 >= count) return;
    v_texCoord = distortion(v_texCoord, 4);
    
    if(5 >= count) return;
    v_texCoord = distortion(v_texCoord, 5);
    
    if(6 >= count) return;
    v_texCoord = distortion(v_texCoord, 6);
    
    if(7 >= count) return;
    v_texCoord = distortion(v_texCoord, 7);
    
    if(8 >= count) return;
    v_texCoord = distortion(v_texCoord, 8);
    
    if(9 >= count) return;
    v_texCoord = distortion(v_texCoord, 9);
    
    if(10 >= count) return;
    v_texCoord = distortion(v_texCoord, 10);
    
    if(11 >= count) return;
    v_texCoord = distortion(v_texCoord, 11);
    
    if(12 >= count) return;
    v_texCoord = distortion(v_texCoord, 12);
    
    if(13 >= count) return;
    v_texCoord = distortion(v_texCoord, 13);
    
    if(14 >= count) return;
    v_texCoord = distortion(v_texCoord, 14);
    
    if(15 >= count) return;
    v_texCoord = distortion(v_texCoord, 15);
    
    if(16 >= count) return;
    v_texCoord = distortion(v_texCoord, 16);
    
    if(17 >= count) return;
    v_texCoord = distortion(v_texCoord, 17);
    
    if(18 >= count) return;
    v_texCoord = distortion(v_texCoord, 18);
    
    if(19 >= count) return;
    v_texCoord = distortion(v_texCoord, 19);

    


}
