#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform sampler2D u_texture;

#ifdef ALPHA
uniform sampler2D u_texture_alpha;
#endif

///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;


void main()
{
    vec4 color = texture2D(u_texture, v_texCoord);
#ifdef ALPHA
    float alpha = texture2D(u_texture_alpha, v_texCoord).r;
    gl_FragColor =  vec4(color.rgb , alpha);
#else
    gl_FragColor =  vec4(color.rgb * color.a , color.a);
#endif
    
    //vec4 bg = vec4(1.0, 0, 0, 1.0);
    //gl_FragColor =  vec4(bg.rgb * (1.0 - color.a) + color.rgb * color.a, 1.0);
    //gl_FragColor = vec4(v_texCoord.x, v_texCoord.y, 0.0, 1.0);

}