attribute vec4 position;
attribute vec4 inputTextureCoordinate;

const int GAUSSIAN_SAMPLES = 9;

uniform float texelWidthOffset;
uniform float texelHeightOffset;

varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main()
{
    gl_Position = position;
    
    blurCoordinates[0] = inputTextureCoordinate.xy + vec2(-texelWidthOffset, -texelHeightOffset);
    blurCoordinates[1] = inputTextureCoordinate.xy + vec2(0, -texelHeightOffset);
    blurCoordinates[2] = inputTextureCoordinate.xy + vec2(texelWidthOffset, -texelHeightOffset);
    blurCoordinates[3] = inputTextureCoordinate.xy + vec2(-texelWidthOffset, 0);
    blurCoordinates[4] = inputTextureCoordinate.xy;
    blurCoordinates[5] = inputTextureCoordinate.xy + vec2(texelWidthOffset, 0);
    blurCoordinates[6] = inputTextureCoordinate.xy + vec2(-texelWidthOffset, texelHeightOffset);
    blurCoordinates[7] = inputTextureCoordinate.xy + vec2(0, texelHeightOffset);
    blurCoordinates[8] = inputTextureCoordinate.xy + vec2(texelWidthOffset, texelHeightOffset);
}