#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform sampler2D u_texture;
uniform bool flipHorizontal;
uniform bool flipVertical;
uniform bool useBGRA;

///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;




void main()
{
    vec2 textureCoord = v_texCoord;
    if(flipHorizontal == true) textureCoord.x = 1.0 - textureCoord.x;
    if(flipVertical == true) textureCoord.y = 1.0 - textureCoord.y;
    
    vec4 color = texture2D(u_texture, textureCoord);

    if(useBGRA == false) {
        gl_FragColor =  vec4(color.rgb * color.a, color.a);
    } else {
        gl_FragColor = vec4(vec3(color.b,color.g,color.r) * color.a, color.a);
    }

    

}