#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform sampler2D u_texture;
uniform float aspectRatio;
uniform vec2 center;
uniform vec2 radius;
uniform float scale;

uniform float u_min;
uniform float u_max;
uniform int debug;

uniform float progress;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;



void main()
{

    if(scale == 0.0) {
        gl_FragColor = texture2D(u_texture, v_texCoord );
        return;;
    }
    
    
    vec2 textureCoordinateToUse = vec2(v_texCoord.x, ((v_texCoord.y - center.y) * aspectRatio) + center.y);
    float dist = distance(center, textureCoordinateToUse);
    textureCoordinateToUse = v_texCoord;
    
    if (dist < radius.x)
    {
        textureCoordinateToUse -= center;
        float percent = 1.0 - ((((radius.x - dist) / radius.x) * scale) * progress);
        percent = percent * percent;
        
        textureCoordinateToUse = textureCoordinateToUse * percent;
        textureCoordinateToUse += center;
        
        
    }
    
    if(textureCoordinateToUse.x < 0.5) {
        gl_FragColor = vec4(1.0, 0, 0, 1.0);
        
    } else {
        
        
    }
    gl_FragColor = texture2D(u_texture, textureCoordinateToUse );


}