#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif



///////////////////////////////////////////////////////////
// Uniforms

uniform sampler2D u_diffuseTexture;


///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;
varying vec3 v_normalVector;
varying vec3 v_cameraDirection;

const vec3 Xunitvec = vec3(1.0, 0.0, 0.0);
const vec3 Yunitvec = vec3(0.0, 1.0, 0.0);

// Color of tint to apply (blue)
const vec4 tintColor = vec4(0.0, 0.0, 1.0, 1.0);
// Amount of tint to apply
const float tintFactor = 0.2;

void main()
{

    
    vec3 reflectDir = reflect(v_cameraDirection, v_normalVector);
    
    
    vec2 texcoord;
    
    texcoord.y = dot(normalize(reflectDir), Yunitvec);
    texcoord.x = dot(normalize(reflectDir), Xunitvec) ;
    
    
    texcoord.t = (texcoord.t + 1.0) * 0.5;
    texcoord.s = (-texcoord.s) * 0.5 + 1.0;
    
    vec4 texColor = texture2D(u_diffuseTexture, texcoord);
    gl_FragColor = mix(texColor, tintColor, tintFactor);

    
}
