/*
 u_worldViewProjectionMatrix = WORLD_VIEW_PROJECTION_MATRIX
 u_worldViewMatrix = WORLD_VIEW_MATRIX
 u_cameraPosition = CAMERA_WORLD_POSITION
 u_inverseTransposeWorldViewMatrix = INVERSE_TRANSPOSE_WORLD_VIEW_MATRIX
 
 
 */

///////////////////////////////////////////////////////////
// Atributes
attribute vec4 a_position;
attribute vec2 a_texCoord;

attribute vec3 a_normal;


///////////////////////////////////////////////////////////
// Uniforms
uniform mat4 u_worldViewProjectionMatrix;
uniform mat4 u_inverseTransposeWorldViewMatrix;
uniform mat4 u_worldViewMatrix;
uniform vec3 u_cameraPosition;

///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;
varying vec3 v_normalVector;
varying vec3 v_cameraDirection;

void main()
{

    gl_Position = u_worldViewProjectionMatrix * a_position;


    vec3 normal = a_normal;
    // Transform the normal, tangent and binormals to view space.
    mat3 inverseTransposeWorldViewMatrix = mat3(u_inverseTransposeWorldViewMatrix[0].xyz, u_inverseTransposeWorldViewMatrix[1].xyz, u_inverseTransposeWorldViewMatrix[2].xyz);
    vec3 normalVector = normalize(inverseTransposeWorldViewMatrix * normal);
    
    v_normalVector = normalVector;
    v_texCoord = a_texCoord;
    
    vec4 positionWorldViewSpace = u_worldViewMatrix * a_position;
    v_cameraDirection = u_cameraPosition - positionWorldViewSpace.xyz;
    
    
}
