#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform sampler2D u_texture;

uniform vec2      offsets[9];
uniform float     blur_kernel[9];



///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;


void main()
{
    vec4 color = vec4(0.0, 0, 0, 1.0);
    
    vec3 sample[9];
    
    for(int i = 0; i < 9; i++)
        sample[i] = vec3(texture2D(u_texture, v_texCoord + offsets[i]));
    
    for(int i = 0; i < 9; i++)
        color += vec4(sample[i] * blur_kernel[i], 0.0);
    
    color.a = 1.0;
    
    gl_FragColor = color;
    
}