#ifdef OPENGL_ES
precision highp float;
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform sampler2D u_texture;
#define MAX_SIZE 31
uniform float kernels[MAX_SIZE];

uniform int kernelSize;

uniform float minSigma;


uniform vec2 textureSize;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;


float normpdf(in float x, in float sigma)
{
    return 0.39894*exp(-0.5*x*x/(sigma*sigma))/sigma;
}

float normpdf3(in vec3 v, in float sigma)
{
    return 0.39894*exp(-0.5*dot(v,v)/(sigma*sigma))/sigma;
}




void main(void)
{
    vec3 c = texture2D(u_texture, v_texCoord).rgb;
    
    //declare stuff
    int kSize = (kernelSize-1)/2;
    vec3 final_colour = vec3(0.0);
    float Z = 0.0;
    
    
    vec3 cc;
    float factor;
    float bZ = 1.0/normpdf(0.0, minSigma);
    
    
    
    //read out the texels
    for (int i=-kSize; i <= kSize; ++i)
    {
        for (int j=-kSize; j <= kSize; ++j)
        {
            cc = texture2D(u_texture, (v_texCoord.xy+vec2(float(i)*textureSize.x,float(j)*textureSize.y)) ).rgb;
            factor = normpdf3(cc-c, minSigma)*bZ*kernels[kSize+j]*kernels[kSize+i];
            Z += factor;
            final_colour += factor*cc;
            
        }
    }
    
    

    gl_FragColor = vec4(final_colour/Z, 1.0);

    

}