#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif
varying highp vec2 v_texCoord;
uniform sampler2D u_texture;
uniform sampler2D u_curve_texture;

void main()
{
    lowp vec4 textureColor = texture2D(u_texture, v_texCoord);
    

    lowp float redCurveValue = texture2D(u_curve_texture, vec2(textureColor.r, 0.0)).r;
    lowp float greenCurveValue = texture2D(u_curve_texture, vec2(textureColor.g, 0.0)).g;
    lowp float blueCurveValue = texture2D(u_curve_texture, vec2(textureColor.b, 0.0)).b;
    
    gl_FragColor = vec4(redCurveValue, greenCurveValue, blueCurveValue, textureColor.a);
}