#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif


#define MAXPOINTS 75

attribute vec2 a_texCoord;
varying vec2 v_texCoord_origin;
varying vec2 v_texCoord;
uniform vec2 p1[MAXPOINTS]; // where the drag started
uniform vec2 p2[MAXPOINTS]; // where the drag ended
uniform float sizes[MAXPOINTS];
uniform lowp int pointCount;
uniform float progress;

void main() {
    
    v_texCoord = a_texCoord; // Set the texture coord to use
    v_texCoord_origin = a_texCoord;
    
    vec2 position = a_texCoord * 2.0 - 1.0; // convert 0 - 1 range to -1 to +1 range
    
    
    
    vec2 aspectRatio = vec2(1.0, 1.333333);
    
    vec2 delta = vec2(0.0, 0.0);
    for (int i = 0; i < pointCount; i++)
    {
        
        vec2 point1 = p1[i];
        vec2 point2 = p2[i];
        
        float dragdistance = distance(point1, point2);
        
        vec2 current = position;
        
        float e1 =  ( current.x - point1.x ) / ( dragdistance );
        float e2 =  ( current.y - point1.y ) / ( dragdistance / aspectRatio.y );
        float d  = sqrt( (e1 * e1) + (e2 * e2));
        
        
        float mydistance = distance(point1, current);
        
        if (d < 1.0)
        {
            
            point1 /= aspectRatio;
            point2 /= aspectRatio;
            
            vec2 maxdistort = (point2 - point1) / sizes[i];
            
            float normalizeddistance = d;
            
            float normalizedimpact = (cos(normalizeddistance*3.14159265359)+1.0)/2.0;
            
            delta += ((maxdistort * normalizedimpact) * progress);
            
            
        }
    }
    
    gl_Position = vec4(position + delta, 0.0, 1.0);
}




